/* Copyright (c) 2004 Konrad Kieling <kkieling@users.sourceforge.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var docarcUrls = new Array( );
var docarcAdded = false;

function docarcInit( )
  {
  if ( ! docarcAdded )
    {
    docarcCreateUrls( );

    docarcAdded = true;
    if ( docarcUrls['pure'] == '' )
      {
      document.getElementById( 'docarc:root' ).setAttribute( 'hidden' , true );
      document.getElementById( 'docarcMenu' ).setAttribute( 'hidden', true );
      document.getElementById( 'docarcContextMenu' ).setAttribute( 'hidden', true );
      }
    else
      {
      if ( Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService ).getBranch( "extensions.docarc." ).
           getBoolPref( "disableMenu" ) )
        {
        document.getElementById( 'docarc:root' ).setAttribute( 'hidden' , true );
        docarcAddModes( );
        }
      else
        {
        docarcAddDS( docarcUrls['docs'] , document.getElementById( 'bookmarks-ptf' ) );
        document.getElementById( 'taskPopup' ).addEventListener( 'popupshowing', docarcAddModes, true );
        }

      document.getElementById( 'contentAreaContextMenu' ).addEventListener( 'popupshowing', docarcTestClipboard, true );
      }
    }
  }

function docarcCheckURL( )
  {
  var p = new XMLHttpRequest( );
  function myFunc( )
    {
    if ( p.responseText != null )
      {
      if ( p.responseText.search( /^empty/ ) == 0 ) { alert( 'URL does not exist in the database' ); }
      else { document.getElementById( 'content' ).loadURI( p.responseText ); }
      }
    else { alert( "Did not get valid reply" ); }
    }
  p.onload=myFunc;
  p.open( 'GET', docarcUrls['pure'] + '?rm=search;queryfield=ur;relation=eq;format=txt;categories=0;limit=1;query=' +
                   escape( document.getElementById( 'content' ).webNavigation.currentURI.spec ), false, '', '' );
  p.send( '' );
  }

function docarcAddModes( )
  { docarcAddDS( docarcUrls['modes'], document.getElementById( 'docarcMenu' ) ); }

function docarcAddDS( rt, tree )
  {
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService( ).QueryInterface( Components.interfaces.nsIRDFService );
  var sources = ( rt + ' ' + tree.getAttribute( "sources" ) ).match( /[^\s]+/g );

  if( sources )
    {
    for( i = 0; i < sources.length; ++ i )
      {
      var ds = Components.classes['@mozilla.org/rdf/datasource;1?name=xml-datasource'].createInstance( Components.interfaces.nsIRDFRemoteDataSource );
      try { ds.Init( sources[i] ); ds.Refresh( false ); } catch ( e ) { ds = rdf.GetDataSource( sources[i] ); }
      tree.database.AddDataSource( ds );
      }
    tree.builder.rebuild( );
    }
  }

function docarcGetPostStream( string )
  {
  var stream = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance( Components.interfaces.nsIStringInputStream );
  var content = [ 'Content-Length: ' + string.length + '\n', string ].join( '\n' );
  stream.setData( content, content.length );

  return stream;
  }

function docarcParseBibTeX( mode, content )
  {
  document.getElementById('content').webNavigation.loadURI(
    docarcUrls['pure'],
    Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
    null,
    docarcGetPostStream( 'rm=mod_parse_bibtex&mode=' + mode + '&cmd=parse&url=' +
                         escape( document.getElementById( 'content' ).webNavigation.currentURI.spec ) + '&content=' + escape( content ) ),
    null
  );
  }

function docarcParseDocument( value )
  {
  var params = value.match( /[^\s]+/g );
  var serializer = new XMLSerializer( );
  docarcParseBibTeX( params[0], serializer.serializeToString( document.getElementById( 'content' ).contentDocument ) );
  }

function docarcParseSelection( )
  {
  var xferable = Components.classes['@mozilla.org/widget/transferable;1'].createInstance( Components.interfaces.nsITransferable );
  var clipboard = Components.classes['@mozilla.org/widget/clipboard;1'].getService( Components.interfaces.nsIClipboard );
  var flavour = { };
  var data    = { };
  var length  = { };

  document.getElementById( 'content' ).contentViewerEdit.copySelection( );

  xferable.addDataFlavor( "text/unicode" );
  clipboard.getData( xferable, Components.interfaces.nsIClipboard.kGlobalClipboard );

  xferable.getAnyTransferData( flavour, data, length );
  docarcParseBibTeX( 'plain', data.value.QueryInterface( Components.interfaces.nsISupportsString ).data );
  }

function docarcTestClipboard( )
  { document.getElementById( 'docarcSelection' ).setAttribute( 'hidden', !document.getElementById( 'content' ).contentViewerEdit.copyable ); }

function docarcCreateUrls( )
  {
  try
    {
    var bmPref = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService ).getBranch( "extensions.docarc." );
    docarcUrls['pure'] = bmPref.getCharPref( 'url' );

    if ( docarcUrls['pure'].search( /(http|https):\/\// ) == 0 )
      {
      var ind = docarcUrls['pure'].search( /:\/\// ) + 3;
      docarcUrls['auth'] = docarcUrls['pure'].substr( 0, ind ) + bmPref.getCharPref( 'username' ) + ':' + bmPref.getCharPref( 'password' ) + '@' +
                           docarcUrls['pure'].substring( ind, docarcUrls['pure'].length );
      }
    else { docarcUrls['auth'] = docarcUrls['pure'] };
    }
  catch ( e ) { }

  docarcUrls['docs']  = docarcUrls['auth'] + '?rm=search&query=&queryfield=any&limit=-1&format=rdf&categories=1';
  docarcUrls['modes'] = docarcUrls['auth'] + '?rm=mod_parse_bibtex&cmd=modeslist&format=rdf';
  }

function docarcTestUrls( t )
  {
  for( i = 0; i < t.childNodes.length; i++ )
    {
    var params = t.childNodes[i].getAttribute( 'value' ).match( /[^\s]+/g );
    if ( ( params ) && ( params.length > 1 ) )
      {
      var regexp = new RegExp( params[1] );
      t.childNodes[i].setAttribute( 'disabled', ! regexp.test( document.getElementById( 'content' ).webNavigation.currentURI.spec ) );
      }
    else { t.childNodes[i].removeAttribute( 'disabled' ); }
    }
  }

function docarcLoadDocument( it )
  {
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService( Components.interfaces.nsIRDFService );
  var RDFC = Components.classes['@mozilla.org/rdf/container;1'].createInstance( ).QueryInterface( Components.interfaces.nsIRDFContainer );

  var _dsource = rdf.GetDataSource( docarcUrls['docs'] );
  var _res     = rdf.GetResource( it );

  try { RDFC.Init( _dsource, _res ); } catch ( e )
    {
    var prop = rdf.GetResource( "http://home.netscape.com/NC-rdf#URL", true );
    var target = _dsource.GetTarget( _res, prop, true );
    if ( target )
      {
      target = target.QueryInterface( Components.interfaces.nsIRDFLiteral ).Value;
      document.getElementById( 'content' ).loadURI( target );
      }
    }
  }

window.addEventListener( "load", docarcInit, true );
